From ec5c396617735d7cef866d9415d9b5891bf6abbc Mon Sep 17 00:00:00 2001
From: Nils Preusker <n.preusker@googlemail.com>
Date: Tue, 16 Dec 2014 14:28:22 +0100
Subject: [PATCH] IE9 compatibility

---
 integration/js/src/main/resources/keycloak.js              | 4 ++--
 integration/js/src/main/resources/login-status-iframe.html | 9 +++++----
 2 files changed, 7 insertions(+), 6 deletions(-)

diff --git a/integration/js/src/main/resources/keycloak.js b/integration/js/src/main/resources/keycloak.js
index 82f92d2..bd4ee5a 100755
--- a/integration/js/src/main/resources/keycloak.js
+++ b/integration/js/src/main/resources/keycloak.js
@@ -594,7 +594,7 @@
                 if (event.origin !== loginIframe.iframeOrigin) {
                     return;
                 }
-                var data = event.data;
+                var data = JSON.parse(event.data);
                 var promise = loginIframe.callbackMap[data.callbackId];
                 delete loginIframe.callbackMap[data.callbackId];
 
@@ -627,7 +627,7 @@
                 msg.callbackId = createCallbackId();
                 loginIframe.callbackMap[msg.callbackId] = promise;
                 var origin = loginIframe.iframeOrigin;
-                loginIframe.iframe.contentWindow.postMessage(msg, origin);
+                loginIframe.iframe.contentWindow.postMessage(JSON.stringify(msg), origin);
             } else {
                 promise.setSuccess();
             }
diff --git a/integration/js/src/main/resources/login-status-iframe.html b/integration/js/src/main/resources/login-status-iframe.html
index a8c6409..8261065 100755
--- a/integration/js/src/main/resources/login-status-iframe.html
+++ b/integration/js/src/main/resources/login-status-iframe.html
@@ -17,14 +17,15 @@
             return;
 
         }
-        event.data.loggedIn = false;
+        var data = JSON.parse(event.data);
+        data.loggedIn = false;
         var cookie = getCookie('KEYCLOAK_SESSION');
         if (cookie) {
-            event.data.loggedIn = true;
-            event.data.session = cookie;
+            data.loggedIn = true;
+            data.session = cookie;
         }
 
-        event.source.postMessage(event.data,
+        event.source.postMessage(JSON.stringify(data),
                 event.origin);
     }
     window.addEventListener("message", receiveMessage, false);
-- 
1.9.3 (Apple Git-50)

